
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Serial_numbersDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const serial_numbers = await db.serial_numbers.create(
            {
                id: data.id || undefined,
        
        serial_number: data.serial_number
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        created_on: data.created_on
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await serial_numbers.setItem( data.item || null, {
            transaction,
        });
        
        await serial_numbers.setLot( data.lot || null, {
            transaction,
        });
        
        await serial_numbers.setProduction_order( data.production_order || null, {
            transaction,
        });
        

        

        

        return serial_numbers;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const serial_numbersData = data.map((item, index) => ({
                id: item.id || undefined,
                
                serial_number: item.serial_number
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                created_on: item.created_on
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const serial_numbers = await db.serial_numbers.bulkCreate(serial_numbersData, { transaction });

        // For each item created, replace relation files
        

        return serial_numbers;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const serial_numbers = await db.serial_numbers.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.serial_number !== undefined) updatePayload.serial_number = data.serial_number;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.created_on !== undefined) updatePayload.created_on = data.created_on;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await serial_numbers.update(updatePayload, {transaction});

        
        
        if (data.item !== undefined) {
            await serial_numbers.setItem(
              
              data.item,
              
              { transaction }
            );
        }
        
        if (data.lot !== undefined) {
            await serial_numbers.setLot(
              
              data.lot,
              
              { transaction }
            );
        }
        
        if (data.production_order !== undefined) {
            await serial_numbers.setProduction_order(
              
              data.production_order,
              
              { transaction }
            );
        }
        

        
        

        

        return serial_numbers;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const serial_numbers = await db.serial_numbers.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of serial_numbers) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of serial_numbers) {
                await record.destroy({transaction});
            }
        });


        return serial_numbers;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const serial_numbers = await db.serial_numbers.findByPk(id, options);

        await serial_numbers.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await serial_numbers.destroy({
            transaction
        });

        return serial_numbers;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const serial_numbers = await db.serial_numbers.findOne(
            { where },
            { transaction },
        );

        if (!serial_numbers) {
            return serial_numbers;
        }

        const output = serial_numbers.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.inventory_transactions_serial_number = await serial_numbers.getInventory_transactions_serial_number({
            transaction
        });
        
        
        output.inspections_serial_number = await serial_numbers.getInspections_serial_number({
            transaction
        });
        
        
        
        output.nonconformances_serial_number = await serial_numbers.getNonconformances_serial_number({
            transaction
        });
        
        
        
        
        
        
        output.item = await serial_numbers.getItem({
            transaction
        });
        
        
        output.lot = await serial_numbers.getLot({
            transaction
        });
        
        
        output.production_order = await serial_numbers.getProduction_order({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.items,
        as: 'item',
        
        where: filter.item ? {
          [Op.or]: [
            { id: { [Op.in]: filter.item.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.item.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.lots,
        as: 'lot',
        
        where: filter.lot ? {
          [Op.or]: [
            { id: { [Op.in]: filter.lot.split('|').map(term => Utils.uuid(term)) } },
            {
              lot_number: {
                [Op.or]: filter.lot.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.production_orders,
        as: 'production_order',
        
        where: filter.production_order ? {
          [Op.or]: [
            { id: { [Op.in]: filter.production_order.split('|').map(term => Utils.uuid(term)) } },
            {
              order_number: {
                [Op.or]: filter.production_order.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.serial_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'serial_numbers',
                        'serial_number',
                        filter.serial_number,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'serial_numbers',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.created_onRange) {
                const [start, end] = filter.created_onRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    created_on: {
                    ...where.created_on,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    created_on: {
                    ...where.created_on,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.serial_numbers.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'serial_numbers',
                        'serial_number',
                        query,
                    ),
                ],
            };
        }

        const records = await db.serial_numbers.findAll({
            attributes: [ 'id', 'serial_number' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['serial_number', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.serial_number,
        }));
    }

    
};

